//+------------------------------------------------------------------+
//|                                                HMAx3 signals.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1

//
//
//
//
//

extern string TimeFrame  = "current time frame";
extern int    HMAPeriod  = 30;
extern int    HMAMethod  = MODE_LWMA;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];


//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,241);
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,242);
      SetIndexBuffer(2,buffer3);
      SetIndexBuffer(3,buffer4);
      SetIndexBuffer(4,buffer5);
      SetIndexBuffer(5,buffer6);
      SetIndexBuffer(6,buffer7);
      SetIndexBuffer(7,buffer8);

   //
   //
   //
   //
   //
   
   int timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName("HMA x3 signals"+TimeFrameToString(timeFrame)+" ("+HMAPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //
            
     for(i = limit; i >= 0; i--)
   {
      buffer1[i] = EMPTY_VALUE;
      buffer2[i] = EMPTY_VALUE;
      buffer3[i] = buffer3[i+1];
      buffer4[i] = buffer4[i+1];
      buffer5[i] = buffer5[i+1];
      buffer6[i] = iCustom(NULL,0,"HMA",TimeFrame,HMAPeriod,PRICE_HIGH ,HMAMethod,0,i);
      buffer7[i] = iCustom(NULL,0,"HMA",TimeFrame,HMAPeriod,PRICE_CLOSE,HMAMethod,0,i);
      buffer8[i] = iCustom(NULL,0,"HMA",TimeFrame,HMAPeriod,PRICE_LOW  ,HMAMethod,0,i);

      //
      //
      //
      //
      //

      if (buffer6[i]>buffer6[i+1]) buffer3[i] =  1;
      if (buffer6[i]<buffer6[i+1]) buffer3[i] = -1;
      if (buffer7[i]>buffer7[i+1]) buffer4[i] =  1;
      if (buffer7[i]<buffer7[i+1]) buffer4[i] = -1;
      if (buffer8[i]>buffer8[i+1]) buffer5[i] =  1;
      if (buffer8[i]<buffer8[i+1]) buffer5[i] = -1;

      //
      //
      //
      //
      //

      int cTrend = buffer3[i]  +buffer4[i]  +buffer5[i];
      int pTrend = buffer3[i+1]+buffer4[i+1]+buffer5[i+1];
 
      if (cTrend== 3 && pTrend !=  3) buffer1[i] = buffer8[i]-iATR(NULL,0,20,i)/2;
      if (cTrend==-3 && pTrend != -3) buffer2[i] = buffer6[i]+iATR(NULL,0,20,i)/2;
   }
   return(0);
}


//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
   if (tf!=Period())
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
}
string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
   {
      char = StringGetChar(s, lenght);
      if((char > 96 && char < 123) || (char > 223 && char < 256))
               s = StringSetChar(s, lenght, char - 32);
      else 
           if(char > -33 && char < 0)
               s = StringSetChar(s, lenght, char + 224);
      lenght--;
   }
   return(s);
}  